#include <cstdio>
#include <ctime>
#include <vector>
#include "states.h"

int yyparse();
int yylex();

void PrettyPrint();

std::vector<State> StateStack;
time_t TimeToDie;

int main(int argc, char *argv[])
{
	if(argc != 2 || atoi(argv[1]) != atoi(getenv("TLIMIT")))
	{
		printf("Something is horribly wrong...\n");
		exit(-1);
	}

	TimeToDie = time(NULL) + atoi(argv[1]) - 3; // 3 seconds for output

	// This is so that we can bail out anywhere in the code and the output
	// will make it out to stdout. If somewhere in the code we realize that
	// we are taking longer than we're supposed to, just exit(0); and everything
	// will be taken care of... as long as StateStack hasn't been corrupted
	atexit(PrettyPrint);

	yyparse();

	return 0;
}

