#include <cstdio>
#include <vector>
#include "states.h"

extern std::vector<State> StateStack;

void PrettyPrint()
{
	std::vector<State>::iterator it;

	State LastState;
	int i=0;
	for(it = StateStack.begin(); it != StateStack.end(); it++)
	{
		if(it->Bold != LastState.Bold)
		{
			if(it->Bold)
				printf("<B>");
			else
				printf("</B>");
		}

		if(it->Emphasis != LastState.Emphasis)
		{
			if(it->Emphasis)
				printf("<EM>");
			else
				printf("</EM>");
		}

		if(it->StrongEmphasis != LastState.StrongEmphasis)
		{
			if(it->StrongEmphasis)
				printf("<S>");
			else
				printf("</S>");
		}

		if(it->Italics != LastState.Italics)
		{
			if(it->Italics)
				printf("<I>");
			else
				printf("</I>");
		}

		if(it->Typewriter != LastState.Typewriter)
		{
			if(it->Typewriter)
				printf("<TT>");
			else
				printf("</TT>");
		}

		if(it->Plain != LastState.Plain)
		{
			if(it->Plain)
				printf("<PL>");
			else
				printf("</PL>");
		}

		if(it->Underline > LastState.Underline)
			for(int i=0; i < (it->Underline - LastState.Underline); i++)
				printf("<U>");

		if(it->Underline < LastState.Underline)
			for(int i=0; i < (LastState.Underline - it->Underline); i++)
				printf("</U>");

		if(it->Size != LastState.Size)
		{
			if(LastState.Size != -1)
				printf("</%d>", LastState.Size);

			if(it->Size != -1)
				printf("<%d>", it->Size);
		}

		if(it->Color != LastState.Color)
		{
			switch(LastState.Color)
			{
			case None:
				break;

			case Red:
				printf("</r>");
				break;

			case Green:
				printf("</g>");
				break;

			case Blue:
				printf("</b>");
				break;

			case Cyan:
				printf("</c>");
				break;

			case Magenta:
				printf("</m>");
				break;

			case Yellow:
				printf("</y>");
				break;

			case Black:
				printf("</k>");
				break;

			case White:
				printf("</w>");
				break;
			}

			switch(it->Color)
			{
			case None:
				break;

			case Red:
				printf("<r>");
				break;

			case Green:
				printf("<g>");
				break;

			case Blue:
				printf("<b>");
				break;

			case Cyan:
				printf("<c>");
				break;

			case Magenta:
				printf("<m>");
				break;

			case Yellow:
				printf("<y>");
				break;

			case Black:
				printf("<k>");
				break;

			case White:
				printf("<w>");
				break;
			}
		}

		printf(it->Text.c_str());
		LastState = *it;
	}
}
