%{
#include "parser.cpp.h"
%}

%option noyywrap

%x SC_TYPEWRITER

%%

<INITIAL,SC_TYPEWRITER><B> { return BOLD; }
<INITIAL,SC_TYPEWRITER><\/B> { return C_BOLD; }

<INITIAL,SC_TYPEWRITER><EM> { return EMPHASIS; }
<INITIAL,SC_TYPEWRITER><\/EM> { return C_EMPHASIS; }

<INITIAL,SC_TYPEWRITER><I> { return ITALICS; }
<INITIAL,SC_TYPEWRITER><\/I> { return C_ITALICS; } 

<INITIAL,SC_TYPEWRITER><PL> { return PLAIN; }
<INITIAL,SC_TYPEWRITER><\/PL> { return C_PLAIN; }  

<INITIAL,SC_TYPEWRITER><S> { return STRONG_EMPHASIS; }
<INITIAL,SC_TYPEWRITER><\/S> { return C_STRONG_EMPHASIS; }

<INITIAL,SC_TYPEWRITER><TT> { BEGIN(SC_TYPEWRITER); return TYPEWRITER; }
<INITIAL,SC_TYPEWRITER><\/TT> { BEGIN(INITIAL); return C_TYPEWRITER; } 

<INITIAL,SC_TYPEWRITER><U> { return UNDERLINE; }
<INITIAL,SC_TYPEWRITER><\/U> { return C_UNDERLINE; } 

<INITIAL,SC_TYPEWRITER><0> { return SIZE_0; }
<INITIAL,SC_TYPEWRITER><\/0> { return C_SIZE_0; }  

<INITIAL,SC_TYPEWRITER><1> { return SIZE_1; }
<INITIAL,SC_TYPEWRITER><\/1> { return C_SIZE_1; } 

<INITIAL,SC_TYPEWRITER><2> { return SIZE_2; }
<INITIAL,SC_TYPEWRITER><\/2> { return C_SIZE_2; } 

<INITIAL,SC_TYPEWRITER><3> { return SIZE_3; }
<INITIAL,SC_TYPEWRITER><\/3> { return C_SIZE_3; }

<INITIAL,SC_TYPEWRITER><4> { return SIZE_4; }
<INITIAL,SC_TYPEWRITER><\/4> { return C_SIZE_4; } 

<INITIAL,SC_TYPEWRITER><5\> { return SIZE_5; }
<INITIAL,SC_TYPEWRITER><\/5\> { return C_SIZE_5; }  

<INITIAL,SC_TYPEWRITER><6\> { return SIZE_6; }
<INITIAL,SC_TYPEWRITER><\/6\> { return C_SIZE_6; } 

<INITIAL,SC_TYPEWRITER><7\> { return SIZE_7; }
<INITIAL,SC_TYPEWRITER><\/7\> { return C_SIZE_7; }  

<INITIAL,SC_TYPEWRITER><8\> { return SIZE_8; }
<INITIAL,SC_TYPEWRITER><\/8\> { return C_SIZE_8; } 

<INITIAL,SC_TYPEWRITER><9\> { return SIZE_9; }
<INITIAL,SC_TYPEWRITER><\/9\> { return C_SIZE_9; }

<INITIAL,SC_TYPEWRITER><r\> { return RED; }
<INITIAL,SC_TYPEWRITER><\/r\> { return C_RED; }

<INITIAL,SC_TYPEWRITER><g\> { return GREEN; }
<INITIAL,SC_TYPEWRITER><\/g\> { return C_GREEN; }

<INITIAL,SC_TYPEWRITER><b\> { return BLUE; }
<INITIAL,SC_TYPEWRITER><\/b\> { return C_BLUE; }

<INITIAL,SC_TYPEWRITER><c\> { return CYAN; }
<INITIAL,SC_TYPEWRITER><\/c\> { return C_CYAN; }

<INITIAL,SC_TYPEWRITER><m\> { return MAGENTA; }
<INITIAL,SC_TYPEWRITER><\/m\> { return C_MAGENTA; }

<INITIAL,SC_TYPEWRITER><y\> { return YELLOW; }
<INITIAL,SC_TYPEWRITER><\/y\> { return C_YELLOW; }

<INITIAL,SC_TYPEWRITER><k\> { return BLACK; }
<INITIAL,SC_TYPEWRITER><\/k\> { return C_BLACK; }

<INITIAL,SC_TYPEWRITER><w\> { return WHITE; }
<INITIAL,SC_TYPEWRITER><\/w\> { return C_WHITE; }

<SC_TYPEWRITER>[^<>]+ { return TEXT; }

<INITIAL>[^<>]+ { return TEXT; }

